<?php

class CategoriesHtmlBuilder {

    public $categories;
    public $urlPrefix;
    public $selectedLocationUrl;

    public $html;

    public function __construct($categories, $urlPrefix, $selectedLocationUrl) {
        $this->categories = $categories;
        $this->urlPrefix = $urlPrefix;
        $this->selectedLocationUrl = $selectedLocationUrl;

        $this->html = '';
    }

    public function getHtml() {
        $this->html = '<ul>';

        foreach ($this->categories as $category) {
            $this->addCategoryLi($category);
        }

        $this->html .= '</ul>';

        return $this->html;
    }

    public function addCategoryLi($category) {
        $class = '';

        if ($category->selected) {
            $class .= ' cat-selected';
        }

        if ($category->leaf) {
            $class .= ' cat-leaf';
        }

        $this->html .= $class ? '<li class="' . $class . '">' : '<li>';

        $url = $this->urlPrefix
            . $category->urlCategory
            . ($this->selectedLocationUrl ? $this->selectedLocationUrl : '');

        $class = $category->selected ? 'a-selected' : '';

        $this->html .= '<a'
            . ($class ? ' class="' . $class . '"' : '')
            . ' href="' . $url . '">';

        $this->html .= $category->name;

        $this->html .= '</a>';

        if (!empty($category->subcategories) && $category->selected) {
            $this->html .= '<ul>';

            foreach ($category->subcategories as $subcategory) {
                $this->addCategoryLi($subcategory);
            }

            $this->html .= '</ul>';
        }
    }
}