<?php

class LocationsHtmlBuilder {

    public $locations;
    public $urlPrefix;
    public $selectedCategoryUrl;

    public $html;

    public function __construct($locations, $urlPrefix, $selectedCategoryUrl) {
        $this->locations = $locations;
        $this->urlPrefix = $urlPrefix;
        $this->selectedCategoryUrl = $selectedCategoryUrl;

        $this->html = '';
    }

    public function getHtml() {
        $this->html = '<ul>';

        foreach ($this->locations as $location) {
            $this->addLocationLi($location);
        }

        $this->html .= '</ul>';

        return $this->html;
    }

    public function addLocationLi($location) {
        $class = '';

        if ($location->selected) {
            $class .= ' cat-selected';
        }

        if ($location->leaf) {
            $class .= ' cat-leaf';
        }

        $this->html .= $class ? '<li class="' . $class . '">' : '<li>';

        $url = $this->urlPrefix
            . ($this->selectedCategoryUrl ? $this->selectedCategoryUrl : '')
            . $location->urlLocation;

        $class = $location->selected ? 'a-selected' : '';

        $this->html .= '<a'
            . ($class ? ' class="' . $class . '"' : '')
            . ' href="' . $url . '">';

        $this->html .= $location->name;

        $this->html .= '</a>';

        if (!empty($location->locations) && $location->selected) {
            $this->html .= '<ul>';

            foreach ($location->locations as $sublocation) {
                $this->addLocationLi($sublocation);
            }

            $this->html .= '</ul>';
        }
    }
}